﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Collections;
using System.Web.UI.Design.WebControls;
using System.Web;
using System.Security.Permissions;
using System.Drawing.Design;


namespace JqueryController
{


    public class JqueryController : Panel
        {
        public PageBase pageContainer { get; set; }
        public IPageBase IPageBase { get; set; }
        public string ClientCallBackFunction { get; set; }      
     
            public JqueryController() {
               
              }



            protected override void OnPreRender(EventArgs e)
            {
                
                base.OnPreRender(e);
                this.AddClientResource();              
            }

            private void AddClientResource()
            {
                const string resourceName = "JqueryController.JqueryController.js";
                ClientScriptManager cs = this.Page.ClientScript;
                cs.RegisterClientScriptResource(typeof(JqueryController), resourceName);
                cs.RegisterClientScriptInclude("JqueryInclude", "http://ajax.googleapis.com/ajax/libs/jquery/1.2.6/jquery.min.js");
            }


            public void RefreshPanel(params string[] callBackParms)
            {
                IPageBase = (IPageBase)this.Page;
                string HtmlToRender = string.Empty;
                IEnumerable<UserControl> controls = this.Controls.OfType<UserControl>();
                if (controls != null)
                {
                    HtmlToRender = RenderFactory.RenderUserControl(controls.First());              
                   
                    IPageBase.AddToRender(this.ClientID, HtmlToRender);
                    IPageBase.PanelRefresh = true;
                    if (string.IsNullOrEmpty(this.ClientCallBackFunction) == false)
                    {
                        IPageBase.AddCallBack(ClientCallBackFunction, callBackParms);
                    }
                }
            }
        }
    }
